Skip to main content
Version: 3.xx.xx
Source Code

useCustomMutation

useCustomMutation is an extended version of TanStack Query's useMutation. It supports all the features of useMutation and adds some extra features.

  • It uses the custom method as the mutation function from the dataProvider which is passed to <Refine>.

It is useful when you want to send a custom mutation request using the TanStack Query advantages.

attention

useCustomMutation should not be used when creating, updating, or deleting a resource. To do these; useCreate, useUpdate or useDelete hooks should be used instead.

This is because useCustomMutation, unlike other data hooks, does not invalidate queries and therefore will not update the application state either.

If you need to custom query request, use the useCustom hook.

Basic Usage​

The useCustomMutation hook returns many useful properties and methods. One of them is the mutate method which expects values, method, and url as parameters. These parameters will be passed to the custom method from the dataProvider as parameters.

import { useCustomMutation, useApiUrl } from "@pankod/refine-core";

interface ICategory {
id: number;
title: string;
}

const apiUrl = useApiUrl();

const { mutate } = useCustomMutation<ICategory>();

mutate({
url: `${API_URL}/categories`,
method: "post",
values: {
title: "New Category",
},
});

Properties​

mutationOptions​

mutationOptions is used to pass options to the useMutation hook. It is useful when you want to pass additional options to the useMutation hook.

Refer to the useMutation documentation for more information →

useCustomMutation({
mutationOptions: {
retry: 3,
},
});
TIP

mutationOptions does not support onSuccess and onError props because they override the default onSuccess and onError functions. If you want to use these props, you can pass them to mutate functions like this:

const { mutate } = useCustomMutation();

mutate(
{
url: `${API_URL}/categories`,
method: "post",
values: {
title: "New Category",
},
},
{
onError: (error, variables, context) => {
// An error occurred!
},
onSuccess: (data, variables, context) => {
// Let's celebrate!
},
},
);

Mutation Parameters​

url
required
​

It will be passed to the custom method from the dataProvider as a parameter. It is usually used to specify the endpoint of the request.

const { mutate } = useCustomMutation();

mutate({
url: "www.example.com/api/update-products",
});

method
required
​

It will be passed to the custom method from the dataProvider as a parameter. It is usually used to specify the HTTP method of the request.

const { mutate } = useCustomMutation();

mutate({
method: "post",
});

values
required
​

It will be passed to the custom method from the dataProvider as a parameter. The parameter is usually used as the data to be sent with the request.

const { mutate } = useCustomMutation();

mutate({
values: {
name: "New Category",
description: "New Category Description",
},
});

config.headers​

It will be passed to the custom method from the dataProvider as a parameter. It can be used to specify the headers of the request.

const { mutate } = useCustomMutation();

mutate({
config: {
headers: {
"x-custom-header": "foo-bar",
},
},
});

successNotification​

NotificationProvider is required for this prop to work.

After data is fetched successfully, useCustomMutation can call open function from NotificationProvider to show a success notification. With this prop, you can customize the success notification.

const { mutate } = useCustomMutation();

mutate({
successNotification: (data, values, resource) => {
return {
message: `${data.title} Successfully fetched.`,
description: "Success with no errors",
type: "success",
};
},
});

errorNotification​

NotificationProvider is required for this prop to work.

After data fetching is failed, useCustomMutation will call open function from NotificationProvider to show an error notification. With this prop, you can customize the error notification.

const { mutate } = useCustomMutation();

mutate({
errorNotification: (data, values, resource) => {
return {
message: `Something went wrong when getting ${data.id}`,
description: "Error",
type: "error",
};
},
});

metaData​

metaData is used following two purposes:

  • To pass additional information to data provider methods.
  • Generate GraphQL queries using plain JavaScript Objects (JSON). Please refer GraphQL for more information.

In the following example, metaData is passed to the custom method from the dataProvider as a parameter.

const { mutate } = useCustomMutation();

mutate({
metaData: {
foo: "bar",
},
});

const myDataProvider = {
//...
custom: async ({
url,
method,
sort,
filters,
payload,
query,
headers,
metaData,
}) => {
const foo = metaData?.foo;

console.log(foo); // "bar"

//...
},
//...
};

dataProviderName​

If there is more than one dataProvider, you can specify which one to use by passing the dataProviderName prop. It is useful when you have a different data provider for different resources.

const { mutate } = useCustomMutation();

mutate({
dataProviderName: "second-data-provider",
});

Return Values​

Returns an object with TanStack Query's useMutation return values.

Refer to the useMutation documentation for more information →

API​

Mutation Parameters​

PropertyDescriptionType
url
Required
URLstring
method
Required
Methodpost, put, patch, delete
values
Required
Values for mutation functionTVariables
configThe config of your request. You can send headers using this field.{ headers?: {}; }
successNotificationSuccessful mutation notificationSuccessErrorNotification
errorNotificationUnsuccessful mutation notificationSuccessErrorNotification
metaDataMetadata query for dataProviderMetaDataQuery
dataProviderNameIf there is more than one dataProvider, you should use the dataProviderName that you will use.string

Type Parameters​

PropertyDesriptionTypeDefault
TDataResult data of the query. Extends BaseRecordBaseRecordBaseRecord
TErrorCustom error object that extends HttpErrorHttpErrorHttpError
TQueryValues for query params.TQueryunknown
TPayloadValues for params.TPayloadunknown

Return value​